
<!doctype html><html lang="en-us">
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<style>
		* { margin:0; padding:0; } /* to remove the top and left whitespace */
		html, body { width:100%; height:100%; background-color:black} /* just to be sure these are full screen*/
		canvas { display:block; } /* To remove the scrollbars */
	</style>
	<link rel="icon" type="image/x-icon" href="resources/epv/favicon.ico">
</head>

<script async type="text/javascript" src="dhviewer.js"></script>

<script>

function connectToStreaming() {

	console.log("init streaming");
	const queryString = window.location.search;
	console.log(queryString);
	const urlParams = new URLSearchParams(queryString);	
	var _study = urlParams.get('study');
	if ( !_study )
		_study="";
	console.log("study: " + _study);
	var _context = urlParams.get('cViewerContextId');
	if ( !_context )
		_context = "";
	console.log("context: " + _context);
	const _user = urlParams.get('cUser');
	console.log("user: " + _user);
	const _session = urlParams.get('authToken');
	console.log("session: " + _session);
	var _streamURL = urlParams.get('streamURL');
	
	if (_streamURL == null) {
		// backward compatible reason, if there is no stream url, then call the old way
		loadPBS();
		return;
		// _streamURL = window.location.origin;
	}

	console.log("stream: " + _streamURL);

	Module._init_streaming( stringToNewUTF8( _streamURL), stringToNewUTF8( _context), stringToNewUTF8( _session), stringToNewUTF8( _user));
};


// obsolete downloading way 
function loadPBS() {

	console.log("legacy loadPBS");
	const queryString = window.location.search;
	console.log(queryString);
	const urlParams = new URLSearchParams(queryString);	
	var _study = urlParams.get('study');
	if ( !_study )
		_study="";
	console.log("study: " + _study);
	var _context = urlParams.get('cViewerContextId');
	if ( !_context )
		_context = "";
	console.log("context: " + _context);
	const _user = urlParams.get('cUser');
	console.log("user: " + _user);
	const _session = urlParams.get('authToken');
	console.log("session: " + _session);


	const pbsurl = window.location.protocol + "//" + window.location.hostname + "/iface/getpbs.jsp?";

	var strRequest = pbsurl;
	var notfirst = false;
	if ( _study && (! _study==="") ) {
		if (notfirst) {
			strRequest += "&";
		} else {
			notfirst = true;
		}
		strRequest += "SYUI=" + encodeURI(_study);
	}
	if ( _context && (!_context=="") ) {
		if (notfirst) {
			strRequest += "&";
		} else {
			notfirst = true;
		}
		strRequest += "VCID=" + encodeURI(_context);
	}

	var xhr = new XMLHttpRequest();
	xhr.open("GET", strRequest);
	xhr.onload = function () {
		if (this.status === 200) {
			var pbs = this.responseText;
			var pbs_length = pbs.length;
			console.log(pbs);
			Module._init_session( stringToNewUTF8(pbs) );
		}
	};
	xhr.send();

};

var have_profile = 0;

// obsolete downloading way
function loadProfile() {

	console.log("legacy loadProfile");

	const pbsurl = window.location.protocol + "//" + window.location.hostname + "/cases/viewer/getuserconfig.jsp";
	var strRequest = pbsurl;

	var xhr = new XMLHttpRequest();
	xhr.open("GET", strRequest);
	xhr.onload = function () {
		if (this.status === 200) {
			var profile = this.responseText;
			var profile_length = profile.length;
			have_profile = 1;
			Module._init_userprofile( stringToNewUTF8(profile) );
		}
	};
	xhr.send();
};	

function drawFrame() {
	Module._refresh_webgl();
	requestAnimationFrame( drawFrame);
}


function init() {
	canvas = document.getElementById('canvas');

	canvas.addEventListener( 'gesturestart', function( event) {
		event.preventDefault();
	}, {capture:true, passive: false});
	canvas.addEventListener( 'gesturechange', function( event) {
		event.preventDefault();
	}, {capture:true, passive: false});
	canvas.addEventListener( 'gestureend', function( event) {
		event.preventDefault();
	}, {capture:true, passive: false});	
	window.addEventListener( 'resize', function( event) {
		resizeCanvas();
	}, true);
	canvas.addEventListener("contextmenu", function( event){
		event.preventDefault();
	}, true);


	document.body.style.overflow = 'hidden';
		
	Module._init_webgl( Module['MAXIMUM_MEMORY'] / (1024 * 1024));
	resizeCanvas();
	
	requestAnimationFrame( drawFrame);
	
	setTimeout( "connectToStreaming()", 10);
}


function draw() {
	Module._refresh_webgl( 0);
}

function forceDraw() {
	Module._refresh_webgl( 1);
}

function imageReady( texName)
{
	Module._refresh_texture( stringToNewUTF8( texName));
}

function queryWindow( path)
{
	var ptr = Module._queryWindow( stringToNewUTF8( path));
	var result = UTF8ToString( ptr);
	Module._freeQueryWindow( ptr);
	if (!result)
		return null;
	return JSON.parse( result);
}

function resizeCanvas() {
	canvas = document.getElementById('canvas');
	console.log("SetSize " + window.innerWidth + "," + window.innerHeight + "," + window.devicePixelRatio);
	canvas.width = window.innerWidth * window.devicePixelRatio;
	canvas.height = window.innerHeight * window.devicePixelRatio;
	Module._OnResize_webgl( canvas.width, canvas.height);
}

var Module = {
	onRuntimeInitialized: function() {
		init();
	},
	'MAXIMUM_MEMORY' : 4 * 1024 * 1024 * 1024
	// 4GB
};


function showDialog() {
	var dialog = document.getElementById('myModalDialog');
	dialog.showModal();
}

function closeDialog() {
	var dialog = document.getElementById('myModalDialog');
	dialog.close();
}

<!--
var oldLog = console.log;
console.log = function(message) {
	// call the original console function
	oldLog.apply(console, arguments);
	// call the new 
	var logDialog = document.getElementById('myLogDialog');
	logDialog.innerHTML += message + "<br>";
};
-->

</script>



<body>
<dialog id="myModalDialog" style="display:none;"></dialog>
<dialog id="myLogDialog" style="width: 100%; height: 100%;border: none; margin: none; text-align: left; opacity: 0.25; display: none;"></dialog>

<!--<button onclick="init()">init</button>
<button onclick="loadPBS()">open</button>  -->

<canvas id='canvas' style='display:block; margin:0px; border:0px' tabindex=1 ></canvas>

</br>
</body>

</html>
